diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/ns3 ns-3.41/ns3
--- ns-3.40/ns3	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/ns3	2024-02-09 14:44:07.845789700 -0800
@@ -1213,24 +1458,31 @@
 
     if run_verbose or args.dry_run:
         exported_variables = "export "
-        for (variable, value) in custom_env.items():
+        for variable, value in custom_env.items():
             if variable == "PATH":
                 value = path_variable + path_sep + libdir
             exported_variables += "%s=%s " % (variable, value)
-        print_and_buffer("cd %s; %s; %s" % (os.path.relpath(ns3_path, working_dir),
-                                            exported_variables,
-                                            " ".join(program_arguments)
-                                            )
-                         )
+        print_and_buffer(
+            "cd %s; %s; %s"
+            % (
+                os.path.relpath(ns3_path, working_dir),
+                exported_variables,
+                " ".join(program_arguments),
+            )
+        )
 
     if not args.dry_run:
         try:
-            subprocess.run(program_arguments, env=proc_env, cwd=working_dir, shell=use_shell, check=True)
+            subprocess.run(
+                program_arguments, env=proc_env, cwd=working_dir, shell=use_shell, check=True
+            )
         except subprocess.CalledProcessError as e:
             # Replace list of arguments with a single string
             e.cmd = " ".join(e.cmd)
             # Replace full path to binary to relative path
-            e.cmd = e.cmd.replace(os.path.abspath(target_to_run), os.path.relpath(target_to_run, ns3_path))
+            e.cmd = e.cmd.replace(
+                os.path.abspath(target_to_run), os.path.relpath(target_to_run, ns3_path)
+            )
             # Print error message and forward the return code
             print(e)
             exit(e.returncode)
@@ -1244,7 +1496,7 @@
 def non_ambiguous_program_target_list(programs: dict) -> list:
     # Assembles a dictionary of all the possible shortcuts a program have
     list_of_shortcuts = {}
-    for (shortcut, possible_programs) in programs.items():
+    for shortcut, possible_programs in programs.items():
         if len(possible_programs) == 1:
             if possible_programs[0] not in list_of_shortcuts:
                 list_of_shortcuts[possible_programs[0]] = [shortcut]
@@ -1294,11 +1546,13 @@
             output += large_item + "\n"
         return output
 
-    print("""Buildable targets:{buildables}\n\nRunnable/Buildable targets:{runnables}
-                  """.format(buildables=list_to_table(sorted(ns3_modules)),
-                             runnables=list_to_table(non_ambiguous_program_target_list(ns3_programs))
-                             )
-          )
+    print(
+        """Buildable targets:{buildables}\n\nRunnable/Buildable targets:{runnables}
+                  """.format(
+            buildables=list_to_table(sorted(ns3_modules)),
+            runnables=list_to_table(non_ambiguous_program_target_list(ns3_programs)),
+        )
+    )
     return
 
 
@@ -1316,16 +1570,26 @@
     if build_version_string is None:
         project_not_configured()
 
-    if build_version_string == '' and shutil.which("git") and os.path.exists(os.path.join(ns3_path, ".git")):
+    if (
+        build_version_string == ""
+        and shutil.which("git")
+        and os.path.exists(append_to_ns3_path(".git"))
+    ):
         try:
-            build_version_string = subprocess.check_output(["git", "describe", "--dirty"], cwd=ns3_path).decode()
-            build_version_string += ("Reconfigure with './ns3 configure --enable-build-version' "
-                                     "to bake the version into the libraries.")
+            build_version_string = subprocess.check_output(
+                ["git", "describe", "--dirty"], cwd=ns3_path
+            ).decode()
+            build_version_string += (
+                "Reconfigure with './ns3 configure --enable-build-version' "
+                "to bake the version into the libraries."
+            )
         except subprocess.CalledProcessError:
             pass
 
-    if build_version_string == '':
-        print("Build version feature disabled. Reconfigure ns-3 with ./ns3 configure --enable-build-version")
+    if build_version_string == "":
+        print(
+            "Build version feature disabled. Reconfigure ns-3 with ./ns3 configure --enable-build-version"
+        )
     else:
         print("ns-3 version: %s" % build_version_string)
 
@@ -1336,18 +1600,18 @@
 # Debugging this with PyCharm is a no no. It refuses to work hanging indefinitely
 def sudo_command(command: list, password: str):
     # Run command and feed the sudo password
-    proc = subprocess.Popen(['sudo', '-S', *command],
-                            stdin=subprocess.PIPE,
-                            stdout=subprocess.PIPE,
-                            stderr=subprocess.PIPE
-                            ).communicate(input=password.encode() + b'\n')
+    proc = subprocess.Popen(
+        ["sudo", "-S", *command],
+        stdin=subprocess.PIPE,
+        stdout=subprocess.PIPE,
+        stderr=subprocess.PIPE,
+    ).communicate(input=password.encode() + b"\n")
     stdout, stderr = proc[0].decode(), proc[1].decode()
 
     # Clean sudo password after each command
-    subprocess.Popen(["sudo", "-k"],
-                     stdin=subprocess.PIPE,
-                     stdout=subprocess.PIPE,
-                     stderr=subprocess.PIPE).communicate()
+    subprocess.Popen(
+        ["sudo", "-k"], stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE
+    ).communicate()
 
     # Check if the password is wrong
     if "try again" in stderr:
@@ -1372,9 +1636,11 @@
     if not args.dry_run:
         if password is None:
             from getpass import getpass
+
             password = getpass(prompt="Sudo password:")
 
     import stat
+
     for target in targets_to_sudo:
         # Check if the file was already built
         if not os.path.exists(target):
@@ -1407,7 +1673,9 @@
     # Check if the user is root and refuse to run
     username = os.getenv("USER", "")
     if username == "root":
-        raise Exception("Refusing to run as root. --enable-sudo will request your password when needed")
+        raise Exception(
+            "Refusing to run as root. --enable-sudo will request your password when needed"
+        )
 
 
 def main():
@@ -1422,7 +1690,7 @@
 
     # If pybindgen exists in the parent directory
     # (e.g. ns3-all-in-one), add it to the PYTHONPATH
-    pybindgen_dir = glob.glob(os.path.abspath(os.path.join(ns3_path, "..", "pybindgen*")))
+    pybindgen_dir = glob.glob(os.path.abspath(append_to_ns3_path("..", "pybindgen*")))
     if pybindgen_dir:
         if "PYTHONPATH" not in os.environ:
             os.environ["PYTHONPATH"] = ""
@@ -1457,9 +1725,9 @@
 
     # Installation and uninstallation options become cmake targets
     if args.install:
-        args.build = ['install']
+        args.build = ["install"]
     if args.uninstall:
-        args.build = ['uninstall']
+        args.build = ["uninstall"]
 
     # Get build profile and other settings
     build_info, ns3_modules = check_lock_data(out_dir)
@@ -1471,10 +1739,14 @@
     # Docs subparser options become cmake targets
     if args.docs:
         args.build = [args.docs] if args.docs != "all" else ["sphinx", "doxygen"]
-        if "doxygen" in args.build and (not build_info["ENABLE_EXAMPLES"] or not build_info["ENABLE_TESTS"]):
-            print('The "./ns3 docs doxygen" and "./ns3 docs all" commands,\n'
-                  'requires examples and tests to generate introspected documentation.\n'
-                  'Try "./ns3 docs doxygen-no-build" or enable examples and tests.')
+        if "doxygen" in args.build and (
+            not build_info["ENABLE_EXAMPLES"] or not build_info["ENABLE_TESTS"]
+        ):
+            print(
+                'The "./ns3 docs doxygen" and "./ns3 docs all" commands,\n'
+                "requires examples and tests to generate introspected documentation.\n"
+                'Try "./ns3 docs doxygen-no-build" or enable examples and tests.'
+            )
             exit(1)
 
     if args.show == "profile":
@@ -1503,7 +1775,7 @@
         if len(target_to_run) > 0:
             # While testing a weird case appeared where the target to run is between quotes,
             # so we remove in case they exist
-            if target_to_run[0] in ["\"", "'"] and target_to_run[-1] in ["\"", "'"]:
+            if target_to_run[0] in ['"', "'"] and target_to_run[-1] in ['"', "'"]:
                 target_to_run = target_to_run[1:-1]
             target_to_run = target_to_run.split()
             target_to_run, target_args = target_to_run[0], target_to_run[1:]
@@ -1521,22 +1793,24 @@
 
         # Check for changes in scratch sources and trigger a reconfiguration if sources changed
         if current_cmake_cache_folder:
-            current_scratch_sources = glob.glob(os.path.join(ns3_path, "scratch", "**", "*.cc"),
-                                                recursive=True)
+            current_scratch_sources = glob.glob(
+                append_to_ns3_path("scratch", "**", "*.cc"), recursive=True
+            )
             scratches_file = os.path.join(current_cmake_cache_folder, "ns3scratches")
             if os.path.exists(scratches_file):
                 with open(scratches_file, "r") as f:
-                    previous_scratches_sources = f.read().split('\n')
+                    previous_scratches_sources = f.read().split("\n")
                     if previous_scratches_sources != current_scratch_sources:
                         refresh_cmake(current_cmake_cache_folder, output)
 
         if args.configure:
-            configuration_step(current_cmake_cache_folder,
-                               current_cmake_generator,
-                               args,
-                               output,
-                               args.dry_run,
-                               )
+            configuration_step(
+                current_cmake_cache_folder,
+                current_cmake_generator,
+                args,
+                output,
+                args.dry_run,
+            )
 
         if not project_configured(current_cmake_cache_folder):
             project_not_configured()
@@ -1560,14 +1834,19 @@
         check_config(current_cmake_cache_folder)
         print("---- Summary of buildable targets:")
         print("Buildable targets:          %4.d" % len(ns3_modules))
-        print("Runnable/Buildable targets: %4.d" % len(non_ambiguous_program_target_list(ns3_programs)))
+        print(
+            "Runnable/Buildable targets: %4.d"
+            % len(non_ambiguous_program_target_list(ns3_programs))
+        )
 
         exit(0)
 
     def check_ambiguous_target(target_type, target_to_check, programs):
         if len(programs[target_to_check]) > 1:
-            print('%s target "%s" is ambiguous. Try one of these: "%s"'
-                  % (target_type, target_to_check, '", "'.join(programs[target_to_check])))
+            print(
+                '%s target "%s" is ambiguous. Try one of these: "%s"'
+                % (target_type, target_to_check, '", "'.join(programs[target_to_check]))
+            )
             exit(1)
         return programs[target_to_check][0]
 
@@ -1584,33 +1863,46 @@
     if "build" in args:
         complete_targets = []
         for target in args.build:
-            build_target = check_ambiguous_target("Build", target, ns3_programs) if target in ns3_programs else target
+            build_target = (
+                check_ambiguous_target("Build", target, ns3_programs)
+                if target in ns3_programs
+                else target
+            )
             complete_targets.append(build_target)
         args.build = complete_targets
         del complete_targets
 
     if not run_only:
-        build_step(args,
-                   build_and_run,
-                   target_to_run,
-                   current_cmake_cache_folder,
-                   ns3_modules,
-                   ns3_version,
-                   build_profile,
-                   output
-                   )
+        build_step(
+            args,
+            build_and_run,
+            target_to_run,
+            current_cmake_cache_folder,
+            ns3_modules,
+            ns3_version,
+            build_profile,
+            output,
+        )
 
     if not args.shell and target_to_run and ".py" not in target_to_run:
         if sys.platform == "win32":
             target_to_run += ".exe"
 
         # If we're only trying to run the target, we need to check if it actually exists first
-        if (run_only or build_and_run) and ".py" not in target_to_run and not os.path.exists(target_to_run):
+        if (
+            (run_only or build_and_run)
+            and ".py" not in target_to_run
+            and not os.path.exists(target_to_run)
+        ):
             raise Exception("Executable has not been built yet")
 
     # Setup program as sudo
     if enable_sudo or (args.run and args.enable_sudo):
-        sudo_step(args, target_to_run, set(map(lambda x: x[0], ns3_programs.values())) if enable_sudo else set())
+        sudo_step(
+            args,
+            target_to_run,
+            set(map(lambda x: x[0], ns3_programs.values())) if enable_sudo else set(),
+        )
 
     # Finally, we try to run it
     if args.shell or run_only or build_and_run:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/pyproject.toml ns-3.41/pyproject.toml
--- ns-3.40/pyproject.toml	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/pyproject.toml	2024-02-09 14:44:07.845789700 -0800
@@ -14,3 +14,11 @@
 
 [tool.cibuildwheel]
 build-frontend = "build"
+
+[tool.black]
+line-length = 100
+include = "\\bns3$|\\.py$"
+
+[tool.isort]
+profile = "black"
+line_length = 100
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/scratch/CMakeLists.txt ns-3.41/scratch/CMakeLists.txt
--- ns-3.40/scratch/CMakeLists.txt	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/scratch/CMakeLists.txt	2024-02-09 14:44:07.845789700 -0800
@@ -14,14 +14,24 @@
     file(READ ${source_file} source_file_contents)
     string(REGEX MATCHALL "main[(| (]" main_position "${source_file_contents}")
     if(CMAKE_MATCH_0)
-      set(scratch_src ${source_file})
+      list(APPEND scratch_src ${source_file})
     endif()
   endforeach()
 
-  if(NOT scratch_src)
-    return()
+  list(LENGTH scratch_src scratch_src_len)
+
+  # If there is no main function, raise an error
+  if(${scratch_src_len} EQUAL 0)
+    message(FATAL_ERROR "The following scratch source files do not contain a main function: ${source_files}")
+  endif()
+
+  # If there are multiple main functions, raise an error
+  if(${scratch_src_len} GREATER 1)
+    message(FATAL_ERROR "The following scratch source files contain ${scratch_src_len} files with a main function: ${scratch_src}")
   endif()
 
+  # If there is a single main function, continue normally
+
   # Get parent directory name
   get_filename_component(scratch_dirname ${scratch_src} DIRECTORY)
   string(REPLACE "${CMAKE_CURRENT_SOURCE_DIR}" "" scratch_dirname
@@ -69,10 +79,9 @@
   create_scratch(${scratch_src})
 endforeach()
 
-# Scan *.cc files in ns-3-dev/scratch subdirectories and build a target for each
-# subdirectory
+# Scan ns-3-dev/scratch subdirectories
 file(
-  GLOB_RECURSE scratch_subdirectories
+  GLOB scratch_subdirectories
   CONFIGURE_DEPENDS
   LIST_DIRECTORIES true
   ${CMAKE_CURRENT_SOURCE_DIR}/**
@@ -84,6 +93,7 @@
   endif()
 endforeach()
 
+# Build scratches per directory or following CMakeLists.txt instructions
 foreach(subdir ${scratch_subdirectories})
   if(EXISTS ${subdir}/CMakeLists.txt)
     # If the subdirectory contains a CMakeLists.txt file
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/setup.py ns-3.41/setup.py
--- ns-3.40/setup.py	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/setup.py	2024-02-09 14:44:07.845789700 -0800
@@ -1,14 +1,15 @@
-import cmake_build_extension
-import setuptools
 import sys
 import sysconfig
 
+import cmake_build_extension
+import setuptools
+
 setuptools.setup(
     cmdclass=dict(build_ext=cmake_build_extension.BuildExtension),
-    packages=['ns', 'visualizer'],
+    packages=["ns", "visualizer"],
     package_dir={
-      'ns': './build-support/pip-wheel/ns',
-      'visualizer': './build-support/pip-wheel/visualizer'
+        "ns": "./build-support/pip-wheel/ns",
+        "visualizer": "./build-support/pip-wheel/visualizer",
     },
     ext_modules=[
         cmake_build_extension.CMakeExtension(
@@ -23,13 +24,12 @@
                 "-DNS3_BINDINGS_INSTALL_DIR:STRING=INSTALL_PREFIX",
                 "-DNS3_FETCH_OPTIONAL_COMPONENTS:BOOL=ON",
                 "-DNS3_PIP_PACKAGING:BOOL=ON",
-                "-DNS3_USE_LIB64:BOOL=ON",
                 # Make CMake find python components from the currently running python
                 # https://catherineh.github.io/programming/2021/11/16/python-binary-distributions-whls-with-c17-cmake-auditwheel-and-manylinux
                 f"-DPython3_LIBRARY_DIRS={sysconfig.get_config_var('LIBDIR')}",
                 f"-DPython3_INCLUDE_DIRS={sysconfig.get_config_var('INCLUDEPY')}",
-                f"-DPython3_EXECUTABLE={sys.executable}"
-            ]
+                f"-DPython3_EXECUTABLE={sys.executable}",
+            ],
         ),
     ],
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/doc/source/conf.py ns-3.41/src/antenna/doc/source/conf.py
--- ns-3.40/src/antenna/doc/source/conf.py	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/doc/source/conf.py	2024-02-09 14:44:07.849789600 -0800
@@ -11,205 +11,209 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-import sys, os
+import os
+import sys
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.insert(0, os.path.abspath('.'))
+# sys.path.insert(0, os.path.abspath('.'))
 
 # -- General configuration -----------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
-#needs_sphinx = '1.0'
+# needs_sphinx = '1.0'
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.imgmath']
+extensions = ["sphinx.ext.imgmath"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix of source filenames.
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
-#source_encoding = 'utf-8-sig'
+# source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'index'
+master_doc = "index"
 
 # General information about the project.
-project = u'LENA'
-copyright = u'2011-2012, CTTC'
+project = "LENA"
+copyright = "2011-2012, CTTC"
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = 'ns-3-dev'
+version = "ns-3-dev"
 # The full version, including alpha/beta/rc tags.
-release = 'ns-3-dev'
+release = "ns-3-dev"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
-#language = None
+# language = None
 
 # There are two options for replacing |today|: either, you set today to some
 # non-false value, then it is used:
-#today = ''
+# today = ''
 # Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
+# today_fmt = '%B %d, %Y'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
+# default_role = None
 
 # If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
+# add_function_parentheses = True
 
 # If true, the current module name will be prepended to all description
 # unit titles (such as .. function::).
-#add_module_names = True
+# add_module_names = True
 
 # If true, sectionauthor and moduleauthor directives will be shown in the
 # output. They are ignored by default.
-#show_authors = False
+# show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
+# modindex_common_prefix = []
 
 
 # -- Options for HTML output ---------------------------------------------------
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'default'
+html_theme = "default"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+# html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-#html_theme_path = []
+# html_theme_path = []
 
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-#html_title = None
+# html_title = None
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+# html_short_title = None
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+# html_logo = None
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+# html_favicon = None
 
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-#html_static_path = ['_static']
+# html_static_path = ['_static']
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-#html_last_updated_fmt = '%b %d, %Y'
+# html_last_updated_fmt = '%b %d, %Y'
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
-#html_use_smartypants = True
+# html_use_smartypants = True
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+# html_sidebars = {}
 
 # Additional templates that should be rendered to pages, maps page names to
 # template names.
-#html_additional_pages = {}
+# html_additional_pages = {}
 
 # If false, no module index is generated.
-#html_domain_indices = True
+# html_domain_indices = True
 
 # If false, no index is generated.
-#html_use_index = True
+# html_use_index = True
 
 # If true, the index is split into individual pages for each letter.
-#html_split_index = False
+# html_split_index = False
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+# html_show_sourcelink = True
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+# html_show_sphinx = True
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+# html_show_copyright = True
 
 # If true, an OpenSearch description file will be output, and all pages will
 # contain a <link> tag referring to it.  The value of this option must be the
 # base URL from which the finished HTML is served.
-#html_use_opensearch = ''
+# html_use_opensearch = ''
 
 # This is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = None
+# html_file_suffix = None
 
 # Output file base name for HTML help builder.
-#htmlhelp_basename = 'ns-3doc'
+# htmlhelp_basename = 'ns-3doc'
 
 
 # -- Options for LaTeX output --------------------------------------------------
 
 # The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
+# latex_paper_size = 'letter'
 
 # The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
+# latex_font_size = '10pt'
 
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('antenna', 'antenna.tex', u'Antenna Module Documentation', u'Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)', 'manual'),
+    (
+        "antenna",
+        "antenna.tex",
+        "Antenna Module Documentation",
+        "Centre Tecnologic de Telecomunicacions de Catalunya (CTTC)",
+        "manual",
+    ),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
-#latex_logo = None
+# latex_logo = None
 
 # For "manual" documents, if this is true, then toplevel headings are parts,
 # not chapters.
-#latex_use_parts = False
+# latex_use_parts = False
 
 # If true, show page references after internal links.
-#latex_show_pagerefs = False
+# latex_show_pagerefs = False
 
 # If true, show URL addresses after external links.
-#latex_show_urls = False
+# latex_show_urls = False
 
 # Additional stuff for the LaTeX preamble.
-#latex_preamble = ''
+# latex_preamble = ''
 
 # Documents to append as an appendix to all manuals.
-#latex_appendices = []
+# latex_appendices = []
 
 # If false, no module index is generated.
-#latex_domain_indices = True
+# latex_domain_indices = True
 
 
 # -- Options for manual page output --------------------------------------------
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-model-library', u'ns-3 Model Library',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-model-library", "ns-3 Model Library", ["ns-3 project"], 1)]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/antenna/model/phased-array-model.cc ns-3.41/src/antenna/model/phased-array-model.cc
--- ns-3.40/src/antenna/model/phased-array-model.cc	2023-09-27 13:30:37.610839000 -0700
+++ ns-3.41/src/antenna/model/phased-array-model.cc	2024-02-09 14:44:07.849789600 -0800
@@ -34,28 +34,6 @@
 
 NS_OBJECT_ENSURE_REGISTERED(PhasedArrayModel);
 
-std::ostream&
-operator<<(std::ostream& os, const PhasedArrayModel::ComplexVector& cv)
-{
-    size_t N = cv.GetSize();
-
-    // empty
-    if (N == 0)
-    {
-        os << "[]";
-        return os;
-    }
-
-    // non-empty
-    os << "[";
-    for (std::size_t i = 0; i < N - 1; ++i)
-    {
-        os << cv[i] << ", ";
-    }
-    os << cv[N - 1] << "]";
-    return os;
-}
-
 PhasedArrayModel::PhasedArrayModel()
     : m_isBfVectorValid{false}
 {
@@ -85,8 +63,8 @@
 PhasedArrayModel::SetBeamformingVector(const ComplexVector& beamformingVector)
 {
     NS_LOG_FUNCTION(this << beamformingVector);
-    NS_ASSERT_MSG(beamformingVector.GetSize() == GetNumberOfElements(),
-                  beamformingVector.GetSize() << " != " << GetNumberOfElements());
+    NS_ASSERT_MSG(beamformingVector.GetSize() == GetNumElems(),
+                  beamformingVector.GetSize() << " != " << GetNumElems());
     m_beamformingVector = beamformingVector;
     m_isBfVectorValid = true;
 }
@@ -101,15 +79,32 @@
     return m_beamformingVector;
 }
 
+const PhasedArrayModel::ComplexVector&
+PhasedArrayModel::GetBeamformingVectorRef() const
+{
+    NS_LOG_FUNCTION(this);
+    NS_ASSERT_MSG(m_isBfVectorValid,
+                  "The beamforming vector should be Set before it's Get, and should refer to the "
+                  "current array configuration");
+    return m_beamformingVector;
+}
+
 PhasedArrayModel::ComplexVector
 PhasedArrayModel::GetBeamformingVector(Angles a) const
 {
     NS_LOG_FUNCTION(this << a);
 
     ComplexVector beamformingVector = GetSteeringVector(a);
-    double normRes = norm(beamformingVector);
+    // The normalization takes into account the total number of ports as only a
+    // portion (K,L) of beam weights associated with a specific port are non-zero.
+    // See 3GPP Section 5.2.2 36.897. This normalization corresponds to
+    // a sub-array partition model (which is different from the full-connection
+    // model). Note that the total number of ports used to perform normalization
+    // is the ratio between the total number of antenna elements and the
+    // number of antenna elements per port.
+    double normRes = norm(beamformingVector) / sqrt(GetNumPorts());
 
-    for (size_t i = 0; i < GetNumberOfElements(); i++)
+    for (size_t i = 0; i < GetNumElems(); i++)
     {
         beamformingVector[i] = std::conj(beamformingVector[i]) / normRes;
     }
@@ -120,8 +115,8 @@
 PhasedArrayModel::ComplexVector
 PhasedArrayModel::GetSteeringVector(Angles a) const
 {
-    ComplexVector steeringVector(GetNumberOfElements());
-    for (size_t i = 0; i < GetNumberOfElements(); i++)
+    ComplexVector steeringVector(GetNumElems());
+    for (size_t i = 0; i < GetNumElems(); i++)
     {
         Vector loc = GetElementLocation(i);
         double phase = -2 * M_PI *
